<?php


///////////////////////////////////////////////////////////////////////////////////////////////
// User Report

function homeroom_course_list_header(&$table, $userid, $sort, $order)
{
	global $wwwBaseUrl;

	unset($table->head);
	unset($table->align);
	unset($table->size);
	unset($table->wrap);

	if ($order=='ASC') $order = 'DESC';
	else			   $order = 'ASC';	

	$linkurl = $wwwBaseUrl.'&amp;userid='.$userid.'&amp;action=crslist';
	$dateurl = $linkurl.'&amp;sort=date';
	$crsurl  = $linkurl.'&amp;sort=courseid';

	// Header
	$table->head [] = '#';
	$table->align[] = 'right';
	$table->size [] = '20px';
	$table->wrap [] = 'nowrap';

	if ($sort=='date') $dateurl.= '&amp;order='.$order;
	$table->head [] = '<a href="'.$dateurl.'">'.get_string('startdate','homeroom').'</a>';
	$table->align[] = 'center';
	$table->size [] = '40px';
	$table->wrap [] = 'nowrap';

	if ($sort=='courseid') $crsurl.= '&amp;order='.$order;
	$table->head [] = '<a href="'.$crsurl.'">'.get_string('course', 'homeroom').'</a>';
	$table->align[] = 'center';
	$table->size [] = '100px';
	$table->wrap [] = 'nowrap';

	$table->head [] = get_string('classname','homeroom');
	$table->align[] = 'center';
	$table->size [] = '80px';
	$table->wrap [] = 'nowrap';

	$table->head [] = get_string('attendgradeshort','homeroom');
	$table->align[] = 'center';
	$table->size [] = '20px';
	$table->wrap [] = 'nowrap';

	$table->head [] = '%';
	$table->align[] = 'center';
	$table->size [] = '40px';
	$table->wrap [] = 'nowrap';

	for ($i=0; $i<5; $i++) {
		$table->align[] = 'center';
		$table->size [] = '20px';
		$table->wrap [] = 'nowrap';
	}
	array_push($table->head, get_string('Pacronym', 'homeroom'),
							 get_string('Lacronym', 'homeroom'),
							 get_string('Eacronym', 'homeroom'),
							 get_string('Xacronym', 'homeroom'),
							 get_string('Yacronym', 'homeroom'));

	return;
}




function homeroom_print_course_list($user, $sort, $order)
{
	global $CFG, $DB, $OUTPUT, $wwwBaseUrl, $TIME_OFFSET;

	if ($sort=='') {
		$sort  = 'date';
		$order = 'DESC';
	}
	if ($order=='') $order = 'DESC';


	$table = new html_table();
	$datas = array();
	$crsurl = $wwwBaseUrl.'&amp;userid='.$user->id.'&amp;action=crsreport';

	$courses = homeroom_get_course_array($user);

	$i = 0;
	foreach($courses as $course) {
		$summary = homeroom_get_user_summary($user->id, $course->id);
		if($summary) {
			$firstdate = reset($summary['attitems']);
			$datas[$i]['date'] 		= strftime(get_string('strftimedmy', 'homeroom'), $firstdate->sessdate + $TIME_OFFSET);
			$datas[$i]['courseid'] 	= $course->id;
			$datas[$i]['fullname'] 	= '<a href="'.$crsurl.'&amp;crsid='.$course->id.'">'.$course->fullname.'</a>';
			$datas[$i]['classname'] = $summary['classname'];
			$datas[$i]['grade'] 	= $summary['grade'].'/'.$summary['maxgrade'];
			$datas[$i]['percent'] 	= $summary['percent'];
			$datas[$i]['P'] 		= $summary['P'];
			$datas[$i]['L'] 		= $summary['L'];
			$datas[$i]['E'] 		= $summary['E'];
			$datas[$i]['X'] 		= $summary['X'];
			$datas[$i]['Y'] 		= $summary['Y'];
			$i++;
		}
	}

	//
	$keys = array();
	foreach ($datas as $key=>$data) {
		$keys[$key] = $data[$sort];
	}
	if ($order=='ASC') array_multisort($keys, SORT_ASC,  $datas);
	else 			   array_multisort($keys, SORT_DESC, $datas);

	//
	if ($CFG->output_idnumber) {
		if (empty($user->idnumber)) $disp_idnum = '[ - ]';
		else $disp_idnum = '['.$user->idnumber.']';
		}
	else $disp_idnum = '';
	//
	include('html/user_report_header.html');

	$i = 0;
	foreach($datas as $data) {
		$table->data[$i][] = $i + 1;
		$table->data[$i][] = $data['date'];
		$table->data[$i][] = $data['fullname'];
		$table->data[$i][] = $data['classname'];
		$table->data[$i][] = $data['grade'];
		$table->data[$i][] = $data['percent'];
		$table->data[$i][] = $data['P'];
		$table->data[$i][] = $data['L'];
		$table->data[$i][] = $data['E'];
		$table->data[$i][] = $data['X'];
		$table->data[$i][] = $data['Y'];
		$i++;

		//
		if ($i%DEFAULT_PAGE_SIZE==0) {
			homeroom_course_list_header($table, $user->id, $sort, $order);
			echo '<div align="center" style="overflow-x: scroll;">';
			echo html_writer::table($table);
			echo '</div><br />';
			unset($table->data);
		}
	}

	if ($i%DEFAULT_PAGE_SIZE!=0 or $i==0) {
		homeroom_course_list_header($table, $user->id, $sort, $order);
		echo '<div align="center" style="overflow-x: scroll;">';
		echo html_writer::table($table);
		echo '</div>';
	}

	echo '</td>';
	echo '</tr>';

/*
    echo '<tr>';
    echo '<td align="center">';    $nowtime_help = $OUTPUT->help_icon('nowtime','homeroom');
    echo $nowtime_help.' '.strftime(get_string('strftimefull', 'homeroom'), time()+$TIME_OFFSET);
    echo '</td>';
    echo '</tr>';
*/

	echo '</table>';

	return;
}




