<?php

//
// １ユーザの全コースの出欠をごちゃ混ぜに出力する
//
//

///////////////////////////////////////////////////////////////////////////////////////////////
// User Report

function homeroom_user_report_header(&$table, $userid, $sort, $order)
{
	global $wwwBaseUrl;
	
	unset($table->head);
	unset($table->align);
	unset($table->size);
	unset($table->wrap);

	if ($order=='ASC') $order = 'DESC';
	else 			   $order = 'ASC';

	$linkurl = $wwwBaseUrl.'&amp;userid='.$userid.'&amp;action=report';
	$dateurl = $linkurl.'&amp;sort=date';

	// Header
	$table->head [] = '#';
	$table->align[] = 'right';
	$table->size [] = '20px';
	$table->wrap [] = 'nowrap';

	if ($sort=='date') $dateurl.= '&amp;order='.$order;
	$table->head [] = '<a href="'.$dateurl.'">'.get_string('date').'</a>';
	$table->align[] = 'center';
	$table->size [] = '40px';
	$table->wrap [] = 'nowrap';

	$table->head [] = get_string('starttime', 'homeroom');
	$table->align[] = 'center';
	$table->size [] = '60px';
	$table->wrap [] = 'nowrap';

	$table->head [] = get_string('endtime', 'homeroom');
	$table->align[] = 'center';
	$table->size [] = '60px';
	$table->wrap [] = 'nowrap';

	$table->head [] = get_string('coursename', 'homeroom');
	$table->align[] = 'center';
	$table->size [] = '100px';
	$table->wrap [] = 'nowrap';

	$table->head [] = get_string('classname', 'homeroom');
	$table->align[] = 'center';
	$table->size [] = '80px';
	$table->wrap [] = 'nowrap';

	$table->head [] = get_string('description','homeroom');
	$table->align[] = 'center';
	$table->size [] = '40px';
	$table->wrap [] = 'nowrap';

	$table->head [] = get_string('status', 'homeroom');
	$table->align[] = 'center';
	$table->size [] = '40px';
	$table->wrap [] = 'nowrap';

	$table->head [] = get_string('callmethod', 'homeroom');
	$table->align[] = 'center';
	$table->size [] = '60px';
	$table->wrap [] = 'nowrap';

	$table->head [] = get_string('calledtime', 'homeroom');
	$table->align[] = 'center';
	$table->size [] = '60px';
	$table->wrap [] = 'nowrap';

    $table->head [] = get_string('ip', 'homeroom');
    $table->align[] = 'center';
    $table->size [] = '80px';
    $table->wrap [] = 'nowrap';

    $table->head [] = get_string('remarks', 'homeroom');
    $table->align[] = 'center';
    $table->size [] = '120px';
    $table->wrap [] = 'nowrap';

	return;
}




//
//
//
function homeroom_print_user_report($user, $sort='', $order='')
{
	global $CFG, $DB, $OUTPUT, $wwwBaseUrl, $TIME_OFFSET;

	if ($sort=='') {
		$sort  = 'date';
		$order = 'DESC';
	}
	if ($order=='') $order = 'DESC';

 	$attends = homeroom_get_all_attends($user, $sort, $order);

	$table = new html_table();
	$linkurl = $wwwBaseUrl.'&amp;userid='.$user->id.'&amp;action=crsreport';

	if ($CFG->output_idnumber) {
		if (empty($user->idnumber)) $disp_idnum = '[ - ]';
		else $disp_idnum = '['.$user->idnumber.']';
	}
	else $disp_idnum = '';

	include('html/user_report_header.html');

	//
	$i = 0;
	foreach($attends as $att) {
		//
		$table->data[$i][] = $i + 1;
		$table->data[$i][] = strftime(get_string('strftimedmyw',   'homeroom'), $att->sessdate  + $TIME_OFFSET);
		$table->data[$i][] = strftime(get_string('strftimehourmin','homeroom'), $att->starttime + $TIME_OFFSET);
		$table->data[$i][] = strftime(get_string('strftimehourmin','homeroom'), $att->endtime   + $TIME_OFFSET);
		$table->data[$i][] = '<a href="'.$linkurl.'&amp;crsid='.$att->course->id.'">'.$att->course->fullname.'</a>';
		$table->data[$i][] = homeroom_get_classname($att->classid);
		$table->data[$i][] = $att->description ? $att->description: get_string('nodescription', 'homeroom');

		if ($att->studentid) {
			if ($att->status=='Y') {
				if (time()>$att->endtime) {
					$table->data[$i][] = get_string('Xacronymfull','homeroom');
				}
				else {
					$table->data[$i][] = get_string('novalue', 'homeroom');
				}
			}
			else {
				$table->data[$i][] = get_string($att->status.'acronymfull','homeroom');
			}
			$table->data[$i][] = get_string($att->called.'methodfull', 'homeroom');
		}
		else {
			$table->data[$i][] = get_string('novalue', 'homeroom');
			$table->data[$i][] = get_string('novalue', 'homeroom');
		}

		//
		if (!$att->studentid OR $att->status==='X' OR $att->status==='Y') {
			$table->data[$i][] = get_string('novalue', 'homeroom');;
		}
		else {
			$sessndate  = strftime(get_string('strftimedmshort', 'homeroom'), $att->sessdate   + $TIME_OFFSET);
			$calleddate = strftime(get_string('strftimedmshort', 'homeroom'), $att->calledtime + $TIME_OFFSET);
			$calledtime = strftime(get_string('strftimehmshort', 'homeroom'), $att->calledtime + $TIME_OFFSET);
			if ($sessndate===$calleddate) {
				$table->data[$i][] = $calledtime;
			}
			else {
				$table->data[$i][] = $calledtime.'&nbsp;('.$calleddate.')';
			}
		}

		//
		$ipaddr = $att->ipaddress ? $att->ipaddress : get_string('novalue', 'homeroom');
		if ($ipaddr) {
			$ipurl = homeroom_get_ipresolv_url($ipaddr);
			if ($ipurl) $table->data[$i][] = "<a href=$ipurl target=_blank>$ipaddr</a>";
			else		$table->data[$i][] = $ipaddr;
		}
		else {
			$table->data[$i][] = get_string('novalue', 'homeroom');
		}

		$table->data[$i][] = $att->remarks;
		$i++;

		//
		if ($i%DEFAULT_PAGE_SIZE==0) {
			homeroom_user_report_header($table, $user->id, $sort, $order);
			echo '<div align="center" style="overflow-x: scroll;">';
			echo html_writer::table($table);
			echo '</div><br />';
			unset($table->data);
		}
	}

	if ($i%DEFAULT_PAGE_SIZE!=0 or $i==0) {
		homeroom_user_report_header($table, $user->id, $sort, $order);
		echo '<div align="center" style="overflow-x: scroll;">';
		echo html_writer::table($table);
		echo '</div>';
	}

	echo '</td>';
	echo '</tr>';

/*
	echo '<tr>';
	echo '<td align="center">';
	$nowtime_help = $OUTPUT->help_icon('nowtime','homeroom');
	echo $nowtime_help.' '.strftime(get_string('strftimefull', 'homeroom'), time()+$TIME_OFFSET);
	echo '</td>';
	echo '</tr>';
*/

	echo '</table>';
	return;
}




